import java.io.*;
import de.fub.bytecode.*;
import de.fub.bytecode.classfile.*;
import de.fub.bytecode.generic.*;
import de.fub.bytecode.Repository;

// Add a method called isShared to a class.  
// Omit the .class extension from the argument.

public class addmethod {
  public static void main(String[] argv) {
    try {
      // Load the class from CLASSPATH.
      System.out.println("Adding field to " + argv[0]);
      JavaClass clazz = Repository.lookupClass(argv[0]);
      ClassGen cg = new ClassGen(clazz);
      
      ConstantPoolGen cpg = cg.getConstantPool();

      InstructionList il = new InstructionList();
      // boolean is encoded as integer in JVM.  
      //0 represents false.
      il.append(new LCONST(0));  
      il.append(new IRETURN());

      MethodGen mg = 
	new MethodGen(Constants.ACC_PUBLIC, Type.BOOLEAN,
		      (new Type[0]), (new String[0]),
		      "isShared", clazz.getClassName(),
		      il, cpg);

      Method m = mg.getMethod();
      cg.addMethod(m);
      JavaClass jc = cg.getJavaClass();

      // Dump the class to <class name>_.class
      // The examples that come with JavaClass don't prepend "./"
      // onto the class name, but without it, I get errors.
      String dumpname = "./" + clazz.getClassName() + "_.class";
      System.out.println("dumping to " + dumpname);
      jc.dump(dumpname);
    } catch(Exception e) { e.printStackTrace(); }
  }

}
